package com.talkweb.recovery.service.impl;

import org.slf4j.LoggerFactory;
import com.talkweb.recovery.dataSource.annotation.TargetDataSource;
import org.springframework.transaction.annotation.Transactional;
import java.util.Iterator;
import java.util.List;
import java.util.ArrayList;
import com.talkweb.recovery.pojo.TprcPtrBean;
import com.talkweb.recovery.utils.DateUtils;
import java.util.Date;
import com.talkweb.pangu.base.common.result.AResultCode;
import com.talkweb.pangu.base.common.result.ResultMap;
import com.talkweb.recovery.pojo.PassidBean;
import javax.annotation.Resource;
import com.talkweb.recovery.dao.TPasstuTransactionCheckMapper;
import com.talkweb.recovery.service.ETCRecoveryDataService;
import com.talkweb.recovery.service.TprcPtrService;
import org.springframework.beans.factory.annotation.Autowired;
import com.talkweb.recovery.service.MongoService;
import org.slf4j.Logger;
import org.springframework.stereotype.Service;
import com.talkweb.recovery.service.EtcDataCheckService;

@Service
public class EtcDataCheckServiceImpl implements EtcDataCheckService
{
    private static final Logger log;
    @Autowired
    private MongoService mongoService;
    @Autowired
    private TprcPtrService tprcPtrService;
    @Autowired
    private ETCRecoveryDataService etcRecoveryDataService;
    @Resource
    private TPasstuTransactionCheckMapper tPasstuTransactionCheckMapper;
    
    public void etcHoutUploadPageList() {
        try {
            final String date = "";
            final String sql = "select ifnull(pid,'') as passid from global_temp.bill_lifecycle_in_etc where trce_extime_1 ='" + date + "' and (ifnull(tranex_pid,'') = '' or ifnull(beex_pid,'') = '') ";
            this.mongoService.searchList(sql, (Class)PassidBean.class);
        }
        catch (final Exception e) {
            EtcDataCheckServiceImpl.log.error(e.getMessage(), e);
        }
    }
    
    public ResultMap<AResultCode, Object> etcOutSplitHandle() {
        final ResultMap<AResultCode, Object> resultMap = (ResultMap<AResultCode, Object>)new ResultMap();
        try {
            final String endDate = DateUtils.getLastMonthEndDay(new Date());
            final String startDate = endDate.substring(0, 7) + "-01";
            final String countSql = "select count(1) as fee  from ( \nselect proposerprovinceid, exid, passid, exvehicleid, exvehicletype, fee, exitfeetype, tollprovinceid, receivablefee, vehicletype, transpaytype, type, \nsum(case when ( case  when type = 1 then get_json_object(col,'$.tranej_serprovinceid') when type in (2,3) then get_json_object(col,'$.serprovinceid') else '' end  ) = '430201'  \nthen ( case  when type = 1 then get_json_object(col,'$.tranej_splitfee')  when type in (2,3) then get_json_object(col,'$.tollfee') else 0 end  ) end) as splitfee from ( \nselect '430201' as proposerprovinceid, tid as exid, pid as passid, tranpt_vehicleid as exvehicleid, tranpt_vehicletype as exvehicletype, \n( case when ifnull(tranej_pid,'')!= '' then  tranej_exfee  when ifnull(etctej_pid,'')!= '' then  etctej_fee  when ifnull(etctpj_pid,'')!= '' then  etctpj_fee  else 4 end ) as fee, \n( case when ifnull(tranej_pid,'')!= '' then  tranej_exitfeetype  when ifnull(etctej_pid,'')!= '' then  etctej_exitfeetype  when ifnull(etctpj_pid,'')!= '' then  etctpj_exitfeetype  else 4 end ) as exitfeetype, \n( case when ifnull(tranej_pid,'')!= '' then  tranej_tollprovinceid  when ifnull(etctej_pid,'')!= '' then  etctej_tollprovinceid  when ifnull(etctpj_pid,'')!= '' then  etctpj_tollprovinceid  else 4 end ) as tollprovinceid, \ntranpt_fee as receivablefee, tranpt_vehicletype as vehicletype, \n( case when ifnull(tranej_pid,'')!= '' then  tranej_exittranstype  when ifnull(etctej_pid,'')!= '' then  etctej_transpaytype  when ifnull(etctpj_pid,'')!= '' then  etctpj_transpaytype  else 4 end ) as transpaytype, \n( case when ifnull(tranej_pid,'')!= '' then  1  when ifnull(etctej_pid,'')!= '' then  2  when ifnull(etctpj_pid,'')!= '' then  3  else 4 end ) as type, \nexplode(json_to_array( case  when ifnull(tranej_pid,'')!= '' then  tranej_splitprovince  when ifnull(etctej_pid,'')!= '' then  etctej_splitprovince  when ifnull(etctpj_pid,'')!= '' then  etctpj_splitprovince  end )) as col  \nfrom global_temp.bill_lifecycle_out_etc where tranpt_extime_1 between '" + startDate + "' and '" + endDate + "' and (ifnull(tranej_pid,'')!= '' or ifnull(etctej_pid,'')!= '' or ifnull(etctpj_pid,'')!= '') and ifnull(tranej_exfee,ifnull(etctej_fee,ifnull(etctpj_fee,0))) != 0   \n) a group by proposerprovinceid, exid, passid, exvehicleid, exvehicletype, fee, exitfeetype, tollprovinceid, receivablefee, vehicletype, transpaytype, type\n) b where (abs(receivablefee - splitfee)/receivablefee > 0.3)";
            final int num = ((TprcPtrBean)this.mongoService.search(countSql, (Class)TprcPtrBean.class)).getFee().intValue();
            final String sql = "select proposerprovinceid, exid, passid, exvehicleid, exvehicletype, fee, splitfee, exitfeetype, tollprovinceid, receivablefee, (receivablefee - splitfee) as differencefee, vehicletype, \nCONCAT('在本次行程中,我省应收金额：',receivablefee,'，我省拆分金额：',splitfee,'，差额为：',(receivablefee - splitfee),'。') as description, transpaytype, \n(case when receivablefee > splitfee then 0  when receivablefee < splitfee then 3 end ) as status from ( \nselect proposerprovinceid, exid, passid, exvehicleid, exvehicletype, fee, exitfeetype, tollprovinceid, receivablefee, vehicletype, transpaytype, type, \nsum(case when ( case  when type = 1 then get_json_object(col,'$.tranej_serprovinceid') when type in (2,3) then get_json_object(col,'$.serprovinceid') else '' end  ) = '430201'  \nthen ( case  when type = 1 then get_json_object(col,'$.tranej_splitfee')  when type in (2,3) then get_json_object(col,'$.tollfee') else 0 end  ) end) as splitfee from ( \nselect '430201' as proposerprovinceid, tid as exid, pid as passid, tranpt_vehicleid as exvehicleid, tranpt_vehicletype as exvehicletype, \n( case when ifnull(tranej_pid,'')!= '' then  tranej_exfee  when ifnull(etctej_pid,'')!= '' then  etctej_fee  when ifnull(etctpj_pid,'')!= '' then  etctpj_fee  else 4 end ) as fee, \n( case when ifnull(tranej_pid,'')!= '' then  tranej_exitfeetype  when ifnull(etctej_pid,'')!= '' then  etctej_exitfeetype  when ifnull(etctpj_pid,'')!= '' then  etctpj_exitfeetype  else 4 end ) as exitfeetype, \n( case when ifnull(tranej_pid,'')!= '' then  tranej_tollprovinceid  when ifnull(etctej_pid,'')!= '' then  etctej_tollprovinceid  when ifnull(etctpj_pid,'')!= '' then  etctpj_tollprovinceid  else 4 end ) as tollprovinceid, \ntranpt_fee as receivablefee, tranpt_vehicletype as vehicletype, \n( case when ifnull(tranej_pid,'')!= '' then  tranej_exittranstype  when ifnull(etctej_pid,'')!= '' then  etctej_transpaytype  when ifnull(etctpj_pid,'')!= '' then  etctpj_transpaytype  else 4 end ) as transpaytype, \n( case when ifnull(tranej_pid,'')!= '' then  1  when ifnull(etctej_pid,'')!= '' then  2  when ifnull(etctpj_pid,'')!= '' then  3  else 4 end ) as type, \nexplode(json_to_array( case  when ifnull(tranej_pid,'')!= '' then  tranej_splitprovince  when ifnull(etctej_pid,'')!= '' then  etctej_splitprovince  when ifnull(etctpj_pid,'')!= '' then  etctpj_splitprovince  end )) as col  \nfrom global_temp.bill_lifecycle_out_etc where tranpt_extime_1 between '" + startDate + "' and '" + endDate + "' and (ifnull(tranej_pid,'')!= '' or ifnull(etctej_pid,'')!= '' or ifnull(etctpj_pid,'')!= '') and ifnull(tranej_exfee,ifnull(etctej_fee,ifnull(etctpj_fee,0))) != 0   \n) a group by proposerprovinceid, exid, passid, exvehicleid, exvehicletype, fee, exitfeetype, tollprovinceid, receivablefee, vehicletype, transpaytype, type \n) b where (abs(receivablefee - splitfee)/receivablefee > 0.3)";
            List<TprcPtrBean> list = new ArrayList<TprcPtrBean>();
            if (num > 30000) {
                for (int i = 1; i <= num; i += 30000) {
                    final int startNum = i;
                    final int endNum = i + 30000;
                    final StringBuffer finalsql = new StringBuffer();
                    finalsql.append("select proposerprovinceid, exid, passid, exvehicleid, exvehicletype, fee, splitfee, exitfeetype, tollprovinceid, receivablefee, differencefee, vehicletype, description, transpaytype, status  from(");
                    finalsql.append("select proposerprovinceid, exid, passid, exvehicleid, exvehicletype, fee, splitfee, exitfeetype, tollprovinceid, receivablefee, differencefee, vehicletype, description, transpaytype, status, row_number() over (order by exid DESC ) rank from ( ");
                    finalsql.append(sql);
                    finalsql.append(") tmp_sales  ) tmp_sales2    where   rank >=" + startNum + " and rank < " + endNum);
                    list = this.mongoService.searchList(finalsql.toString(), (Class)TprcPtrBean.class);
                    for (final TprcPtrBean tprcPtrBean : list) {
                        tprcPtrBean.setRateversion(this.getRateversion(tprcPtrBean.getPassid()));
                        tprcPtrBean.setEvidence(this.etcRecoveryDataService.makeEvidenceData(tprcPtrBean.getPassid()));
                        this.tprcPtrService.insert(tprcPtrBean);
                    }
                }
            }
            else {
                list = this.mongoService.searchList(sql, (Class)TprcPtrBean.class);
                for (final TprcPtrBean tprcPtrBean2 : list) {
                    tprcPtrBean2.setRateversion(this.getRateversion(tprcPtrBean2.getPassid()));
                    tprcPtrBean2.setEvidence(this.etcRecoveryDataService.makeEvidenceData(tprcPtrBean2.getPassid()));
                    this.tprcPtrService.insert(tprcPtrBean2);
                }
            }
        }
        catch (final Exception e) {
            EtcDataCheckServiceImpl.log.error(e.getMessage(), e);
            resultMap.setCode((Object)AResultCode.FAIL);
        }
        resultMap.setCode((Object)AResultCode.OK);
        return resultMap;
    }
    
    @Transactional(value = "defaultTx", rollbackFor = { Exception.class })
    @TargetDataSource(name = "first")
    public String getRateversion(final String passid) {
        return this.tPasstuTransactionCheckMapper.getRateversion(passid);
    }
    
    static {
        log = LoggerFactory.getLogger(EtcDataCheckServiceImpl.class);
    }
}
